Loading...
Searching...
No Matches
casacore::MaskedLattice< T > Class Template Referenceabstract
lattices package (libcasa_lattices) » Lattices_module

More...

`#include <MaskedLattice.h>`

## Public Member Functions

| MaskedLattice ()
| Default constructor.
| MaskedLattice (const MaskedLattice< T > &)
| Copy constructor.
virtual | ~MaskedLattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual MaskedLattice< T > * | cloneML () const =0
| Make a copy of the object (reference semantics).
virtual Lattice< T > * | clone () const
| Make a copy of the derived object (reference semantics).
virtual Bool | isMasked () const
| Has the object really a mask?
virtual Bool | hasPixelMask () const
| Does the lattice have a pixelmask?
virtual const Lattice< Bool > & | pixelMask () const
| Get access to the pixelmask.
virtual Lattice< Bool > & | pixelMask ()
const LatticeRegion & | region () const
| Get the region used.
Bool | getMask (COWPtr< Array< Bool > > &buffer, Bool removeDegenerateAxes=False) const
| Get the mask or a slice from the mask.
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
Bool | getMask (Array< Bool > &buffer, Bool removeDegenerateAxes=False)
Bool | getMaskSlice (Array< Bool > &buffer, const Slicer &section, Bool removeDegenerateAxes=False)
Bool | getMaskSlice (Array< Bool > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False)
Bool | getMaskSlice (Array< Bool > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False)
Array< Bool > | getMask (Bool removeDegenerateAxes=False) const
Array< Bool > | getMaskSlice (const Slicer &section, Bool removeDegenerateAxes=False) const
Array< Bool > | getMaskSlice (const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Array< Bool > | getMaskSlice (const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
virtual Bool | doGetMaskSlice (Array< Bool > &buffer, const Slicer &section)
| The function (in the derived classes) doing the actual work.
Public Member Functions inherited from casacore::Lattice< T >
virtual | ~Lattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual DataType | dataType () const
| Get the data type of the lattice.
T | operator() (const IPosition &where) const
| Return the value of the single element located at the argument IPosition.
virtual T | getAt (const IPosition &where) const
virtual void | putAt (const T &value, const IPosition &where)
| Put the value of a single element.
Bool | get (COWPtr< Array< T > > &buffer, Bool removeDegenerateAxes=False) const
| Functions which extract an Array of values from a Lattice.
Bool | getSlice (COWPtr< Array< T > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
Bool | getSlice (COWPtr< Array< T > > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Bool | getSlice (COWPtr< Array< T > > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
Bool | get (Array< T > &buffer, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const Slicer &section, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False)
Array< T > | get (Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const Slicer &section, Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
void | putSlice (const Array< T > &sourceBuffer, const IPosition &where, const IPosition &stride)
| A function which places an Array of values within this instance of the Lattice at the location specified by the IPosition "where", incrementing by "stride".
void | putSlice (const Array< T > &sourceBuffer, const IPosition &where)
void | put (const Array< T > &sourceBuffer)
virtual void | set (const T &value)
| Set all elements in the Lattice to the given value.
virtual void | apply (T(*function)(T))
| Replace every element, x, of the Lattice with the result of f(x).
virtual void | apply (T(*function)(const T &))
virtual void | apply (const Functional< T, T > &function)
void | operator+= (const Lattice< T > &other)
| Add, subtract, multiple, or divide by another Lattice.
void | operator-= (const Lattice< T > &other)
void | operator*= (const Lattice< T > &other)
void | operator/= (const Lattice< T > &other)
virtual void | copyData (const Lattice< T > &from)
| Copy the data from the given lattice to this one.
virtual void | copyDataTo (Lattice< T > &to) const
| Copy the data from this lattice to the given lattice.
virtual uInt | advisedMaxPixels () const
| This function returns the advised maximum number of pixels to include in the cursor of an iterator.
virtual LatticeIterInterface< T > * | makeIter (const LatticeNavigator &navigator, Bool useRef) const
| These functions are used by the LatticeIterator class to generate an iterator of the correct type for a specified Lattice.
virtual Bool | doGetSlice (Array< T > &buffer, const Slicer &section)=0
| The functions (in the derived classes) doing the actual work.
virtual void | doPutSlice (const Array< T > &buffer, const IPosition &where, const IPosition &stride)=0
Public Member Functions inherited from casacore::LatticeBase
virtual | ~LatticeBase ()
| A virtual destructor is needed so that it will use the actual destructor in the derived class.
virtual String | imageType () const
| Get the image type (returns name of derived class).
virtual Bool | isPersistent () const
| Is the lattice persistent and can it be loaded by other processes as well?
virtual Bool | isPaged () const
| Is the lattice paged to disk?
virtual Bool | canReferenceArray () const
| Can the lattice data be referenced as an array section?
virtual Bool | isWritable () const
| Is the lattice writable?
virtual void | save (const String &fileName) const
| Save the image in an AipsIO file with the given name.
virtual Bool | lock (FileLocker::LockType, uInt nattempts)
| It is strongly recommended to use class LatticeLocker to handle lattice locking.
virtual void | unlock ()
virtual Bool | hasLock (FileLocker::LockType) const
virtual void | resync ()
| Resynchronize the Lattice object with the lattice file.
virtual void | flush ()
| Flush the data (but do not unlock).
virtual void | tempClose ()
| Temporarily close the lattice.
virtual void | reopen ()
| Explicitly reopen the temporarily closed lattice.
virtual String | name (Bool stripPath=False) const
| Return the name of the current Lattice object.
virtual IPosition | shape () const =0
| Return the shape of the Lattice including all degenerate axes (ie.
virtual uInt | ndim () const
| Return the number of axes in this Lattice.
virtual size_t | nelements () const
| Return the total number of elements in this Lattice.
size_t | size () const
Bool | conform (const LatticeBase &other) const
| Return a value of "True" if this instance of Lattice and 'other' have the same shape, otherwise returns a value of "False".
virtual LELCoordinates | lelCoordinates () const
| Return the coordinates of the lattice.
IPosition | niceCursorShape (uInt maxPixels) const
| Returns a recommended cursor shape for iterating through all the pixels in the Lattice.
IPosition | niceCursorShape () const
virtual Bool | ok () const
| Check class internals - used for debugging.
virtual IPosition | doNiceCursorShape (uInt maxPixels) const
| The function (in the derived classes) doing the actual work.
virtual uInt | maximumCacheSize () const
| Maximum cache size - not necessarily all used.
virtual void | setMaximumCacheSize (uInt howManyPixels)
| Set the maximum (allowed) cache size as indicated.
virtual void | setCacheSizeInTiles (uInt howManyTiles)
| Set the actual cache size for this Array to be big enough for the indicated number of tiles.
virtual void | setCacheSizeFromPath (const IPosition &sliceShape, const IPosition &windowStart, const IPosition &windowLength, const IPosition &axisPath)
| Set the cache size as to "fit" the indicated path.
virtual void | clearCache ()
| Clears and frees up the caches, but the maximum allowed cache size is unchanged from when setCacheSize was called.
virtual void | showCacheStatistics (ostream &os) const
| Report on cache success.

## Protected Member Functions

MaskedLattice< T > & | operator= (const MaskedLattice< T > &)
| Assignment can only be used by derived classes.
virtual const LatticeRegion * | getRegionPtr () const =0
| Get a pointer to the region used.
Protected Member Functions inherited from casacore::Lattice< T >
| Lattice ()
| Define default constructor to satisfy compiler.
virtual void | handleMath (const Lattice< T > &from, int oper)
| Handle the Math operators (+=, -=, *=, /=).
virtual void | handleMathTo (Lattice< T > &to, int oper) const
| Lattice (const Lattice< T > &)
| Copy constructor and assignment can only be used by derived classes.
Lattice< T > & | operator= (const Lattice< T > &)
void | handleMathTo (Lattice< Bool > &, int) const
Protected Member Functions inherited from casacore::LatticeBase
| LatticeBase ()
| Define default constructor to be used by derived classes.
| LatticeBase (const LatticeBase &)
| Copy constructor and assignment can only be used by derived classes.
LatticeBase & | operator= (const LatticeBase &)
void | throwBoolMath () const
| Throw an exception for arithmetic on a Bool Lattice.

## Private Attributes

LatticeRegion * | itsDefRegPtr

## Detailed Description

template<class T>
class casacore::MaskedLattice< T >

A templated, abstract base class for array-like objects with masks.

### Intended use:

Public interface

### Review Status

Date Reviewed:
  yyyy/mm/dd
Demo programs:
  dLattice

### Prerequisite

- IPosition
- Abstract Base class Inheritance - try "Advanced C++" by James O. Coplien, Ch. 5.

### Etymology

Lattice: "A regular, periodic configuration of points, particles, or objects, throughout an area of a space..." (American Heritage Directory) This definition matches our own: an n-dimensional arrangement of items, on regular orthogonal axes.

### Synopsis

This pure abstract base class defines the operations which may be performed on any concrete class derived from it. It has only a few non-pure virtual member functions. The fundamental contribution of this class, therefore, is that it defines the operations derived classes must provide:

- how to extract a "slice" (or sub-array, or subsection) from a Lattice.
- how to copy a slice in.
- how to get and put a single element
- how to apply a function to all elements
- various shape related functions.

Tip: Lattices are always zero origined;

### Example

Because Lattice is an abstract base class, an actual instance of this class cannot be constructed. However the interface it defines can be used inside a function. This is always recommended as it allows Functions which have Lattices as arguments to work for any derived class.

I will give a few examples here and then refer the reader to the ArrayLattice class (a memory resident Lattice) and the PagedArray class (a disk based Lattice) which contain further examples with concrete classes (rather than an abstract one). All the examples shown below are used in the dLattice.cc demo program.

#### Example 1:

This example calculates the mean of the Lattice. Because Lattices can be too large to fit into physical memory it is not good enough to simply use getSlice to read all the elements into an Array. Instead the Lattice is accessed in chunks which can fit into memory (the size is determined by the maxPixels and niceCursorShape functions). The LatticeIterator::cursor() function then returns each of these chunks as an Array and the standard Array based functions are used to calculate the mean on each of these chunks. Functions like this one are the recommended way to access Lattices as the LatticeIterator will correctly setup any required caches.

Complex latMean(const Lattice<Complex>& lat) {
const uInt cursorSize = lat.advisedMaxPixels();
const IPosition cursorShape = lat.niceCursorShape(cursorSize);
const IPosition latticeShape = lat.shape();
Complex currentSum = 0.0f;
size_t nPixels = 0;
RO_LatticeIterator<Complex> iter(lat,
LatticeStepper(latticeShape, cursorShape));
for (iter.reset(); !iter.atEnd(); iter++){
currentSum += sum(iter.cursor());
nPixels += iter.cursor().nelements();
}
return currentSum/nPixels;
}
casacore::IPosition
Definition IPosition.h:117
casacore::LatticeBase::shape
virtual IPosition shape() const =0
Return the shape of the Lattice including all degenerate axes (ie.
casacore::LatticeBase::niceCursorShape
IPosition niceCursorShape(uInt maxPixels) const
Returns a recommended cursor shape for iterating through all the pixels in the Lattice.
Definition LatticeBase.h:206
casacore::LatticeStepper
Definition LatticeStepper.h:266
casacore::Lattice::Lattice
Lattice()
Define default constructor to satisfy compiler.
Definition Lattice.h:405
casacore::Lattice::advisedMaxPixels
virtual uInt advisedMaxPixels() const
This function returns the advised maximum number of pixels to include in the cursor of an iterator.
casacore::RO_LatticeIterator
Definition LatticeIterator.h:203
casacore::sum
LatticeExprNode sum(const LatticeExprNode &expr)
casacore::uInt
unsigned int uInt
Definition aipstype.h:49

#### Example 2:

Sometimes it will be neccesary to access slices of a Lattice in a nearly random way. Often this can be done using the subSection commands in the LatticeStepper class. But it is also possible to use the getSlice and putSlice functions. The following example does a two-dimensional Real to Complex Fourier transform. This example is restricted to four-dimensional Arrays (unlike the previous example) and does not set up any caches (caching is currently only used with PagedArrays). So only use getSlice and putSlice when things cannot be done using LatticeIterators.

void FFT2DReal2Complex(Lattice<Complex>& result,
const Lattice<Float>& input){
AlwaysAssert(input.ndim() == 4, AipsError);
const IPosition shape = input.shape();
const uInt nx = shape(0);
AlwaysAssert (nx > 1, AipsError);
const uInt ny = shape(1);
AlwaysAssert (ny > 1, AipsError);
const uInt npol = shape(2);
const uInt nchan = shape(3);
const IPosition resultShape = result.shape();
AlwaysAssert(resultShape.nelements() == 4, AipsError);
AlwaysAssert(resultShape(3) == nchan, AipsError);
AlwaysAssert(resultShape(2) == npol, AipsError);
AlwaysAssert(resultShape(1) == ny, AipsError);
AlwaysAssert(resultShape(0) == nx/2 + 1, AipsError);
const IPosition inputSliceShape(4,nx,ny,1,1);
const IPosition resultSliceShape(4,nx/2+1,ny,1,1);
COWPtr<Array<Float>>
inputArrPtr(new Array<Float>(inputSliceShape.nonDegenerate()));
Array<Complex> resultArray(resultSliceShape.nonDegenerate());
FFTServer<Float, Complex> FFT2D(inputSliceShape.nonDegenerate());
IPosition start(4,0);
Bool isARef;
for (uInt c = 0; c < nchan; c++){
for (uInt p = 0; p < npol; p++){
isARef = input.getSlice(inputArrPtr,
Slicer(start,inputSliceShape), True);
FFT2D.fft(resultArray, *inputArrPtr);
result.putSlice(resultArray, start);
start(2) += 1;
}
start(2) = 0;
start(3) += 1;
}
}
AlwaysAssert
#define AlwaysAssert(expr, exception)
These marcos are provided for use instead of simply using the constructors of assert_ to allow additi...
Definition Assert.h:155
casacore::AipsError
Definition Error.h:133
casacore::Array
Definition Array.h:155
casacore::COWPtr
Definition COWPtr.h:183
casacore::FFTServer
A class with methods for Fast Fourier Transforms.
Definition FFTServer.h:226
casacore::IPosition::nelements
size_t nelements() const
The number of elements in this IPosition.
Definition IPosition.h:566
casacore::LatticeBase::ndim
virtual uInt ndim() const
Return the number of axes in this Lattice.
casacore::Lattice::getSlice
Bool getSlice(COWPtr< Array< T > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
casacore::Lattice::putSlice
void putSlice(const Array< T > &sourceBuffer, const IPosition &where, const IPosition &stride)
A function which places an Array of values within this instance of the Lattice at the location specif...
Definition Lattice.h:327
casacore::Slicer
Definition Slicer.h:287
casacore::shape
IPosition shape(const RecordFieldId &) const
Get the actual shape of this field.
casacore::Bool
bool Bool
Define the standard types used by Casacore.
Definition aipstype.h:40
casacore::True
const Bool True
Definition aipstype.h:41

#### Example 3:

Occasionally you may want to access a few elements of a Lattice without all the difficulty involved in setting up Iterators or calling getSlice and putSlice. This is demonstrated in the example below and uses the parenthesis operator, along with the LatticeValueRef companion class. Using these functions to access many elements of a Lattice is not recommended as this is the slowest access method.

In this example an ideal point spread function will be inserted into an empty Lattice. As with the previous examples all the action occurs inside a function because Lattice is an interface (abstract) class.

void makePsf(Lattice<Float>& psf) {
const IPosition centrePos = psf.shape()/2;
psf.set(0.0f); // this sets all the elements to zero
// As it uses a LatticeIterator it is efficient
psf(centrePos) = 1; // This sets just the centre element to one
AlwaysAssert(near(psf(centrePos), 1.0f, 1E-6), AipsError);
AlwaysAssert(near(psf(centrePos*0), 0.0f, 1E-6), AipsError);
}
casacore::Lattice::set
virtual void set(const T &value)
Set all elements in the Lattice to the given value.
casacore::near
Bool near(const GaussianBeam &left, const GaussianBeam &other, const Double relWidthTol, const Quantity &absPaTol)

### Motivation

Creating an abstract base class which provides a common interface between memory and disk based arrays has a number of advantages.

- It allows functions common to all arrays to be written independent of the way the data is stored. This is illustrated in the three examples above.
- It reduces the learning curve for new users who only have to become familiar with one interface (ie. Lattice) rather than distinct interfaces for different array types.

Definition at line 215 of file MaskedLattice.h.

## Constructor & Destructor Documentation

## MaskedLattice() [1/2]

template<class T>

casacore::MaskedLattice< T >::MaskedLattice | ( |  | ) |

inline

Default constructor.

Definition at line 224 of file MaskedLattice.h.

References itsDefRegPtr.

Referenced by casacore::CurvedLattice2D< T >::cloneML(), casacore::ExtendLattice< T >::cloneML(), casacore::ImageInterface< T >::cloneML(), casacore::LatticeExpr< T >::cloneML(), cloneML(), casacore::RebinLattice< T >::cloneML(), casacore::SubLattice< T >::cloneML(), casacore::CurvedLattice2D< T >::CurvedLattice2D(), casacore::ExtendLattice< T >::ExtendLattice(), casacore::LatticeConcat< T >::lattice(), MaskedLattice(), operator=(), casacore::RebinLattice< T >::RebinLattice(), casacore::LatticeConcat< T >::setLattice(), casacore::ExtendLattice< T >::setPtr(), casacore::SubLattice< T >::setPtr(), casacore::SubLattice< T >::SubLattice(), casacore::SubLattice< T >::SubLattice(), casacore::SubLattice< T >::SubLattice(), casacore::SubLattice< T >::SubLattice(), casacore::SubLattice< T >::SubLattice(), and casacore::SubLattice< T >::SubLattice().

## MaskedLattice() [2/2]

template<class T>

casacore::MaskedLattice< T >::MaskedLattice | ( | const MaskedLattice< T > & |  | ) |

Copy constructor.

References MaskedLattice().

## ~MaskedLattice()

template<class T>

virtual casacore::MaskedLattice< T >::~MaskedLattice | ( |  | ) |

virtual

a virtual destructor is needed so that it will use the actual destructor in the derived class

## Member Function Documentation

## clone()

template<class T>

virtual Lattice< T > * casacore::MaskedLattice< T >::clone | ( |  | ) | const

virtual

Make a copy of the derived object (reference semantics).

Implements casacore::Lattice< T >.

References casacore::Lattice< T >::Lattice().

## cloneML()

template<class T>

virtual MaskedLattice< T > * casacore::MaskedLattice< T >::cloneML | ( |  | ) | const

pure virtual

Make a copy of the object (reference semantics).

Implemented in casacore::CurvedLattice2D< T >, casacore::ExtendLattice< T >, casacore::ImageInterface< T >, casacore::ImageInterface< Bool >, casacore::ImageInterface< Complex >, casacore::ImageInterface< DComplex >, casacore::ImageInterface< Double >, casacore::ImageInterface< Float >, casacore::LatticeConcat< T >, casacore::LatticeExpr< T >, casacore::LatticeExpr< Bool >, casacore::RebinLattice< T >, and casacore::SubLattice< T >.

References MaskedLattice().

## doGetMaskSlice()

template<class T>

virtual Bool casacore::MaskedLattice< T >::doGetMaskSlice | ( | Array< Bool > & | buffer,
|  | const Slicer & | section )

virtual

The function (in the derived classes) doing the actual work.

These functions are public, so they can be used internally in the various Lattice classes.
However, doGetMaskSlice does not call Slicer::inferShapeFromSource to fill in possible unspecified section values. Therefore one should normally use one of the getMask(Slice) functions. doGetMaskSlice should be used with care and only when performance is an issue.
The default implementation gets the mask from the region and fills the buffer with True values if there is no region.

Reimplemented in casacore::CurvedImage2D< T >, casacore::CurvedLattice2D< T >, casacore::ExtendImage< T >, casacore::ExtendLattice< T >, casacore::FITSImage, casacore::FITSQualityImage, casacore::ImageConcat< T >, casacore::ImageExpr< T >, casacore::ImageExpr< Bool >, casacore::LatticeConcat< T >, casacore::LatticeExpr< T >, casacore::LatticeExpr< Bool >, casacore::MIRIADImage, casacore::RebinImage< T >, casacore::RebinLattice< T >, casacore::SubImage< T >, casacore::SubLattice< T >, and casacore::TempImage< T >.

## getMask() [1/3]

template<class T>

Bool casacore::MaskedLattice< T >::getMask | ( | Array< Bool > & | buffer,
|  | Bool | removeDegenerateAxes = False )

References casacore::False.

## getMask() [2/3]

template<class T>

Array< Bool > casacore::MaskedLattice< T >::getMask | ( | Bool | removeDegenerateAxes = False | ) | const

References casacore::False.

## getMask() [3/3]

template<class T>

Bool casacore::MaskedLattice< T >::getMask | ( | COWPtr< Array< Bool > > & | buffer,
|  | Bool | removeDegenerateAxes = False ) const

Get the mask or a slice from the mask.

This is the mask formed by combination of the possible pixelmask of the lattice and the possible mask of the region taken from the lattice. If there is no mask, it still works fine. In that case it sizes the buffer correctly and sets it to True.

References casacore::False.

## getMaskSlice() [1/9]

template<class T>

Bool casacore::MaskedLattice< T >::getMaskSlice | ( | Array< Bool > & | buffer,
|  | const IPosition & | start,
|  | const IPosition & | shape,
|  | Bool | removeDegenerateAxes = False )

References casacore::False, and casacore::shape().

## getMaskSlice() [2/9]

template<class T>

Bool casacore::MaskedLattice< T >::getMaskSlice | ( | Array< Bool > & | buffer,
|  | const IPosition & | start,
|  | const IPosition & | shape,
|  | const IPosition & | stride,
|  | Bool | removeDegenerateAxes = False )

References casacore::False, and casacore::shape().

## getMaskSlice() [3/9]

template<class T>

Bool casacore::MaskedLattice< T >::getMaskSlice | ( | Array< Bool > & | buffer,
|  | const Slicer & | section,
|  | Bool | removeDegenerateAxes = False )

References casacore::False.

## getMaskSlice() [4/9]

template<class T>

Array< Bool > casacore::MaskedLattice< T >::getMaskSlice | ( | const IPosition & | start,
|  | const IPosition & | shape,
|  | Bool | removeDegenerateAxes = False ) const

References casacore::False, and casacore::shape().

## getMaskSlice() [5/9]

template<class T>

Array< Bool > casacore::MaskedLattice< T >::getMaskSlice | ( | const IPosition & | start,
|  | const IPosition & | shape,
|  | const IPosition & | stride,
|  | Bool | removeDegenerateAxes = False ) const

References casacore::False, and casacore::shape().

## getMaskSlice() [6/9]

template<class T>

Array< Bool > casacore::MaskedLattice< T >::getMaskSlice | ( | const Slicer & | section,
|  | Bool | removeDegenerateAxes = False ) const

References casacore::False.

## getMaskSlice() [7/9]

template<class T>

Bool casacore::MaskedLattice< T >::getMaskSlice | ( | COWPtr< Array< Bool > > & | buffer,
|  | const IPosition & | start,
|  | const IPosition & | shape,
|  | Bool | removeDegenerateAxes = False ) const

References casacore::False, and casacore::shape().

## getMaskSlice() [8/9]

template<class T>

Bool casacore::MaskedLattice< T >::getMaskSlice | ( | COWPtr< Array< Bool > > & | buffer,
|  | const IPosition & | start,
|  | const IPosition & | shape,
|  | const IPosition & | stride,
|  | Bool | removeDegenerateAxes = False ) const

References casacore::False, and casacore::shape().

## getMaskSlice() [9/9]

template<class T>

Bool casacore::MaskedLattice< T >::getMaskSlice | ( | COWPtr< Array< Bool > > & | buffer,
|  | const Slicer & | section,
|  | Bool | removeDegenerateAxes = False ) const

References casacore::False.

## getRegionPtr()

template<class T>

virtual const LatticeRegion * casacore::MaskedLattice< T >::getRegionPtr | ( |  | ) | const

protected pure virtual

Get a pointer to the region used.

It can return 0 meaning that the MaskedLattice is the full lattice.

Implemented in casacore::CurvedImage2D< T >, casacore::CurvedLattice2D< T >, casacore::ExtendImage< T >, casacore::ExtendLattice< T >, casacore::FITSImage, casacore::FITSQualityImage, casacore::HDF5Image< T >, casacore::ImageConcat< T >, casacore::ImageExpr< T >, casacore::ImageExpr< Bool >, casacore::LatticeConcat< T >, casacore::LatticeExpr< T >, casacore::LatticeExpr< Bool >, casacore::MIRIADImage, casacore::PagedImage< T >, casacore::RebinImage< T >, casacore::RebinLattice< T >, casacore::SubImage< T >, casacore::SubLattice< T >, and casacore::TempImage< T >.

## hasPixelMask()

template<class T>

virtual Bool casacore::MaskedLattice< T >::hasPixelMask | ( |  | ) | const

virtual

Does the lattice have a pixelmask?

The default implementation returns False.

Reimplemented in casacore::CurvedImage2D< T >, casacore::ExtendImage< T >, casacore::ExtendLattice< T >, casacore::FITSImage, casacore::FITSQualityImage, casacore::HDF5Image< T >, casacore::ImageConcat< T >, casacore::LatticeConcat< T >, casacore::MIRIADImage, casacore::PagedImage< T >, casacore::RebinImage< T >, casacore::SubImage< T >, casacore::SubLattice< T >, and casacore::TempImage< T >.

## isMasked()

template<class T>

virtual Bool casacore::MaskedLattice< T >::isMasked | ( |  | ) | const

virtual

Has the object really a mask?

The default implementation returns True if the MaskedLattice has a region with a mask.

Reimplemented in casacore::CurvedImage2D< T >, casacore::CurvedLattice2D< T >, casacore::ExtendImage< T >, casacore::ExtendLattice< T >, casacore::FITSImage, casacore::FITSQualityImage, casacore::ImageConcat< T >, casacore::ImageExpr< T >, casacore::ImageExpr< Bool >, casacore::LatticeConcat< T >, casacore::LatticeExpr< T >, casacore::LatticeExpr< Bool >, casacore::MIRIADImage, casacore::RebinImage< T >, casacore::RebinLattice< T >, casacore::SubImage< T >, casacore::SubLattice< T >, and casacore::TempImage< T >.

## operator=()

template<class T>

MaskedLattice< T > & casacore::MaskedLattice< T >::operator= | ( | const MaskedLattice< T > & |  | ) |

protected

Assignment can only be used by derived classes.

References MaskedLattice().

## pixelMask() [1/2]

template<class T>

virtual Lattice< Bool > & casacore::MaskedLattice< T >::pixelMask | ( |  | ) |

virtual

Reimplemented in casacore::CurvedImage2D< T >, casacore::ExtendImage< T >, casacore::ExtendLattice< T >, casacore::HDF5Image< T >, casacore::ImageConcat< T >, casacore::LatticeConcat< T >, casacore::PagedImage< T >, casacore::RebinImage< T >, casacore::SubImage< T >, casacore::SubLattice< T >, and casacore::TempImage< T >.

References casacore::Lattice< T >::Lattice().

## pixelMask() [2/2]

template<class T>

virtual const Lattice< Bool > & casacore::MaskedLattice< T >::pixelMask | ( |  | ) | const

virtual

Get access to the pixelmask.

An exception is thrown if the lattice does not have a pixelmask.

Reimplemented in casacore::CurvedImage2D< T >, casacore::ExtendImage< T >, casacore::ExtendLattice< T >, casacore::FITSImage, casacore::FITSQualityImage, casacore::HDF5Image< T >, casacore::ImageConcat< T >, casacore::LatticeConcat< T >, casacore::MIRIADImage, casacore::PagedImage< T >, casacore::RebinImage< T >, casacore::SubImage< T >, casacore::SubLattice< T >, and casacore::TempImage< T >.

References casacore::Lattice< T >::Lattice().

## region()

template<class T>

const LatticeRegion & casacore::MaskedLattice< T >::region | ( |  | ) | const

Get the region used.

This is in principle the region pointed to by getRegionPtr. However, if that pointer is 0, it returns a LatticeRegion for the full image.

Referenced by casacore::ImageInterface< T >::defineRegion(), casacore::SubLattice< T >::setRegion(), casacore::SubImage< T >::SubImage(), casacore::SubImage< T >::SubImage(), casacore::SubLattice< T >::SubLattice(), casacore::SubLattice< T >::SubLattice(), casacore::SubLattice< T >::SubLattice(), and casacore::SubLattice< T >::SubLattice().

## Member Data Documentation

## itsDefRegPtr

template<class T>

LatticeRegion* casacore::MaskedLattice< T >::itsDefRegPtr

mutable private

Definition at line 319 of file MaskedLattice.h.

Referenced by MaskedLattice().

The documentation for this class was generated from the following files:

- images/Images/ImageConcat.h
- lattices/Lattices/MaskedLattice.h